package com.gxwebsoft.love.controller;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.*;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.love.entity.ChatConversation;
import com.gxwebsoft.love.param.ChatConversationParam;
import com.gxwebsoft.love.service.ChatConversationService;
import com.gxwebsoft.love.vo.ChatConversationVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 聊天消息表控制器
 *
 * @author 科技小王子
 * @since 2023-06-15 21:26:48
 */
@Api(tags = "聊天消息表管理")
@RestController
@RequestMapping("/api/love/chat-conversation")
public class ChatConversationController extends BaseController {
    @Resource
    private ChatConversationService chatConversationService;

    //    @PreAuthorize("hasAuthority('love:chatConversation:list')")
    @OperationLog
    @ApiOperation("查询全部聊天消息表")
    @GetMapping("/app")
    public ApiResult<List<ChatConversationVO>> appList() {

        ChatConversationParam param = new ChatConversationParam();
        param.setUserId(getLoginUserId());
        return success(chatConversationService.getFriendList(param));
    }


    @OperationLog
    @ApiOperation("标记已读")
    @PostMapping("/app/read")
    public ApiResult<Boolean> read(@RequestBody ChatConversationParam param) {
        return success(chatConversationService.update(
                new LambdaUpdateWrapper<ChatConversation>().eq(ChatConversation::getId, param.getId()).set(ChatConversation::getUnRead, 0)
        ));
        // 使用关联查询
        //return success(chatConversationService.pageRel(param));
    }


    @PreAuthorize("hasAuthority('love:chatConversation:list')")
    @OperationLog
    @ApiOperation("分页查询聊天消息表")
    @GetMapping("/page")
    public ApiResult<PageResult<ChatConversationVO>> page(ChatConversationParam param) {
        PageParam<ChatConversation, ChatConversationParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
//        return success(chatConversationService.page(page, page.getWrapper()));
        // 使用关联查询
        return success(chatConversationService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('love:chatConversation:list')")
    @OperationLog
    @ApiOperation("查询全部聊天消息表")
    @GetMapping()
    public ApiResult<List<ChatConversation>> list(ChatConversationParam param) {
        PageParam<ChatConversation, ChatConversationParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
//        return success(chatConversationService.list(page.getOrderWrapper()));
        // 使用关联查询
        return success(chatConversationService.listRel(param));
    }

    @PreAuthorize("hasAuthority('love:chatConversation:list')")
    @OperationLog
    @ApiOperation("根据id查询聊天消息表")
    @GetMapping("/{id}")
    public ApiResult<ChatConversation> get(@PathVariable("id") Integer id) {
        return success(chatConversationService.getById(id));
        // 使用关联查询
        //return success(chatConversationService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('love:chatConversation:save')")
    @OperationLog
    @ApiOperation("添加聊天消息表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ChatConversation chatConversation) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            chatConversation.setUserId(loginUser.getUserId());
        }
        if (chatConversationService.save(chatConversation)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('love:chatConversation:update')")
    @OperationLog
    @ApiOperation("修改聊天消息表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ChatConversation chatConversation) {
        if (chatConversationService.updateById(chatConversation)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @OperationLog
    @ApiOperation("删除聊天消息表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (chatConversationService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('love:chatConversation:save')")
    @OperationLog
    @ApiOperation("批量添加聊天消息表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ChatConversation> list) {
        if (chatConversationService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('love:chatConversation:update')")
    @OperationLog
    @ApiOperation("批量修改聊天消息表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ChatConversation> batchParam) {
        if (batchParam.update(chatConversationService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('love:chatConversation:remove')")
    @OperationLog
    @ApiOperation("批量删除聊天消息表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (chatConversationService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
